#include "voltage_check_ide.h"		// Additional Header

#define SUBGHZ_CH		36
#define SUBGHZ_PANID	0xABCD
#define SUBGHZ_BAUD		100
#define SUBGHZ_PWR		20
#define SUBGHZ_DSTADDR	0x7FAD

char txdata[250];
void print_voltage(uint8_t level) {
	Print.init(txdata,sizeof(txdata));
	Print.p("LDO Level : ");
	switch (level) {
	case VLS_UNDER_1_898:
		Print.p("< 1.898V");
		break;
	case VLS_1_898:
		Print.p("1.898 ~ 2.000V");
		break;
	case VLS_2_000:
		Print.p("2.000 ~ 2.093V");
		break;
	case VLS_2_093:
		Print.p("2.093 ~ 2.196V");
		break;
	case VLS_2_196:
		Print.p("2.196 ~ 2.309V");
		break;
	case VLS_2_309:
		Print.p("2.309 ~ 2.409V");
		break;
	case VLS_2_409:
		Print.p("2.409 ~ 2.605V");
		break;
	case VLS_2_605:
		Print.p("2.605 ~ 2.800V");
		break;
	case VLS_2_800:
		Print.p("2.800 ~ 3.068V");
		break;
	case VLS_3_068:
		Print.p("3.068 ~ 3.394V");
		break;
	case VLS_3_394:
		Print.p("3.394 ~ 3.797V");
		break;
	case VLS_3_797:
		Print.p("3.797 ~ 4.226V");
		break;
	case VLS_4_226:
		Print.p("4.226 ~ 4.667V");
		break;
	case VLS_4_667:
		Print.p("> 4.667V");
		break;
	default:
		Print.p("unknown");
		break;
	}
}

void setup() {
	Serial.begin(115200);
	SubGHz.init();
	analogReadResolution(12);
}

void loop() {
	uint8_t ldo_level;
	float vdd_level;

	ldo_level = voltage_check(VLS_4_667);		// start checking from 4.667V
	print_voltage(ldo_level);
	vdd_level = ((float)(analogRead(A0)*2)/4096)*3.3f;
	Print.p("\tVDD Level: ");
	Print.f(vdd_level,2);
	Print.ln();
	Serial.print(txdata);
	SubGHz.begin(SUBGHZ_CH,SUBGHZ_PANID,SUBGHZ_BAUD,SUBGHZ_PWR);
	SubGHz.send(SUBGHZ_PANID,SUBGHZ_DSTADDR,txdata,Print.len(),NULL);
	SubGHz.close();
	sleep(3000);
}
